﻿using System;
using System.ComponentModel;
using System.Web.UI;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.WebControls;

namespace Mindsharp.WebParts.Public
{
  public class VisualPart :
    System.Web.UI.WebControls.WebParts.WebPart
  {
    // Public Property to demonstrate that the end user can personalize this Web Part
    // and the User Control can utilize the results of that personalization
    [WebBrowsable(true)
   , Personalizable(PersonalizationScope.User)
   , WebDisplayName("Part Property Text")
   , WebDescription("Part Property Tooltip")
   , Category("Web Part")
   ]
    public string PartProperty { get; set; }


    // Load a strongly typed User Control (ASCX) as the User Interface for this Web Part
    protected override void CreateChildControls()
    {
      try
      {
        Panel div = new Panel();

        // Since Page.LoadControl requires Full Trust
        // Do not load the User Control directly from this assembly like this:
        //div.Controls.Add(new LiteralControl("Full Trust Web Part"));
        //Controls.Add(div);

        //VisualPartControl uc =
        //  Page.LoadControl("~/_controltemplates/Custom/VisualPartControl.ascx")
        //    as VisualPartControl;

        // Instead, create an instance of a privileged assembly in the GAC
        // that is sandboxed for use by assemblies using a custom CAS IPermission
        // Subsequently, get the strongly typed User Control from the sandboxed assembly
        div.Controls.Add(new LiteralControl("Partial Trust Web Part"));
        Controls.Add(div);

        Mindsharp.Utilities.PrivilegedSandbox sandboxedAssembly =
          new Mindsharp.Utilities.PrivilegedSandbox();

        VisualPartControl uc =
          sandboxedAssembly.LoadControl("~/_controltemplates/Custom/VisualPartControl.ascx")
            as VisualPartControl;


        uc.ControlProperty = "From Web Part";

        // Add it to the controls collection for this Web Part
        Controls.Add(uc);

      }
      catch (Exception ex)
      {
        Controls.Clear();
        Controls.Add(new LiteralControl("Message: " + ex.Message));
      }
      finally
      {
        base.CreateChildControls();
      }
    }
  }
}